/*
  mechanism for easy (fast) detection if an object has changed internally
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */





#ifndef __INFO_H
#define __INFO_H



/**
  This class is delveloped for the entriey in a deviceConfig 
  class.<p>
  Eg. The musicInfo class in deviceConfig. If it changes
  there must be a fast way to check by another thread
  that it has changed. The other thread stores a deviceConfig
  as well. And if the musicInfo has changed it must copy
  the data to its own deviceConfig.
  <p>
  The info class has a mechanism which does not determins changes
  by eg. strcmp(..) the different entry. Instead it increments a 
  counter and the two deviceConfig entries simply compare
  the counters (the "version") and if they math everything
  is all right, otherwise they caller can update itself
  <p>
*/


class Info {

  int counter;

 public:

  Info();
  ~Info();

  void incCounter();
  int getCounter();

};


#endif
